



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C# Ref 与out 的区别</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C# Ref 与out 的区别</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 17:29:34 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在C#中，有四种传递参数方式：</p>
<p>1. 传值 （value） : 无额外修饰符</p>
<p>2. 传址(reference) ： 需修饰符Ref，传入函数的参数必须先赋值</p>
<p>3. 输出参数（output）： 需修饰符out,适用于return多个返回值，必须在方法中赋值</p>
<p>4.数组参数 (array):需修饰符params</p>
<p>引用网上一段话：ref 是有进有出（进时需赋值，内部可以修改，并且修改后的值函数结束后仍将保留）</p>
<p>而out是只出不进 （外部即便赋值，也不会传入函数内，编译器将提示该参数未被初始化，在函数内必须赋值，修改后和Ref参数一样，其值将保留）</p>
<div>
<pre class="prettyprint linenums">class Program<br />
    {<br />
        static void Main(string[] args)<br />
        {<br />
            int m = 0;// ref 参数使用前必须初始化赋值<br />
              int k=100; // out 参数使用前不用初始化赋值，即便初始化，当使用out引用后，编译器仍将认为其未初始化<br />
              MessageBox.Show(k.ToString()); //返回100<br />
            MessageBox.Show(RefValue(1, ref m).ToString());//返回1<br />
            MessageBox.Show(m.ToString());//返回222<br />
            MessageBox.Show(OutValue(1, out k).ToString());//返回223<br />
            MessageBox.Show(k.ToString());//返回222<br />
        }

        private static int RefValue(int i, ref int j)<br />
        {<br />
            int k = j;<br />
            j = 222;<br />
            return i + k;<br />
        }

        private static int OutValue(int i, out int j)<br />
        {<br />
            //int k = j; //即便在外部定义了j=100 ,但任然无法使用，编译器提示未初始化<br />
            j = 222;<br />
            return i + j;<br />
        }<br />
    }</pre>
</div>
<p>传值参数在方法中如果改变了参数的值，其改变后的值只能在方法内使用，方法调用完成后参数只会保留原来传入时的值。</p>
<p>通过以上测试，可以看到out 和ref 应用骏相当于传递指针，故其修改将直接修改原参数的值。</p>
<p>网上看到：<a href="http://greatverve.cnblogs.com/archive/2012/02/27/ref-out.html" rel="external nofollow noreferrer">http://greatverve.cnblogs.com/archive/2012/02/27/ref-out.html</a></p>
<p>属性不是变量，不能作为ref 和out参数传递，这里记录下来</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2j3l38.html">js 字符串操作函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/4950kr68.html">餐厅点餐系统app总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96mz5n8.html">ABAP 数量单位转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql3x06q.html">IOS第三方字体</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oeme19.html">Python使用libsvm的&OpenCurlyDoubleQuote;ImportError&colon; No module named svmutil&rdquo;问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wjzlwq.html">HDU-4035 Maze （概率DP求期望）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okvj659.html">如何自定义一个优雅的ContentProvider</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd4modq.html">【转】深入浅出异步I&sol;O模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv73xxq.html">UDP 广播  Java</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0owz4q.html">ecshop模板如何修改详细图解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1dv5d9.html">showModalDialog&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj0e779.html">AngularJS 的一些坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yxn2eq.html">java之集合类特性对比分析列表</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg5krr8.html">Android学习路径（四）文件项目学习的名单，android显示单元经常使用的</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxklnlv8.html">怎样正确设置remote&lowbar;addr和x&lowbar;forwarded&lowbar;for</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zor27xq.html">cf734   E&period; Anton and Tree</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyj31j9.html">XML编辑工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m57vo8.html">&lbrack;SCOI2009&rsqb;windy数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z12o59.html">Android Stutio中使用java8的Lambda表达式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z0g7e9.html">nginx负载均衡指令least&lowbar;conn的真正含义</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qydlz2dq.html">基于mongoDB的capped collection的性能优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwde35k8.html">实验记录贴 &mdash;&mdash; 账号同步实验 RTX 和 LDAP（AD域）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e17zwx9.html">xcode5&period;1 armv7 armv7s arm64 类型&comma; 区分&comma; 概念等</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1lxr59.html">zabbix监控redis多实例（low level discovery）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnv152q.html">ActionBar 中setDisplayHomeAsUpEnabled和setHomeButtonEnabled和setDisplayShowHomeEnabled方法的理解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1k7mk8.html">Json数据异步绑定到界面的Table并且自动刷新</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xl5dw9.html">win7下安装load generator</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y2ej5q.html">RedHat&sol;CentOS系统信息查看命令大全</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdpkel8.html">usaco 地震 &amp;amp&semi;&amp;amp&semi; 奶牛观光</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k16j579.html">PAT 1017&period; Queueing at Bank</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
